> For the complete documentation index, see [llms.txt](https://docs.servoy.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.servoy.com/reference/servoyextensions/server-plugins/oauth/customapibuilder.md).

# CustomApiBuilder

## Overview

The `CustomApiBuilder` facilitates the configuration of the OAuth plugin for integration with less common or custom providers, including in-house solutions. This includes options for parsing and handling tokens, specifying request methods, and configuring authentication and endpoint URLs for token-related operations such as access, refresh, and revocation.

It supports methods to customize the API by enabling access token extraction, specifying token request methods, defining client authentication mechanisms, and setting up refresh and revoke token endpoints, allowing integration with a variety of OAuth implementations.

## Methods Summarized

| Type                                                                                     | Name                                                                                             | Summary                                                                                                     |
| ---------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------ | ----------------------------------------------------------------------------------------------------------- |
| [CustomApiBuilder](/reference/servoyextensions/server-plugins/oauth/customapibuilder.md) | [withAccessTokenExtractor(accessTokenExtractor)](#withaccesstokenextractor-accesstokenextractor) | Configures the api with a token extractor which parses the concrete type of token from the response string. |
| [CustomApiBuilder](/reference/servoyextensions/server-plugins/oauth/customapibuilder.md) | [withAccessTokenMethod(tokenRequestMethod)](#withaccesstokenmethod-tokenrequestmethod)           | The request method used for the access token endpoint (defaults to POST).                                   |
| [CustomApiBuilder](/reference/servoyextensions/server-plugins/oauth/customapibuilder.md) | [withClientAuthentication(clientAuthentication)](#withclientauthentication-clientauthentication) | Configures the api with a client authentication method which specifies how the client credentials are sent. |
| [CustomApiBuilder](/reference/servoyextensions/server-plugins/oauth/customapibuilder.md) | [withRefreshTokenEndpoint(refreshTokenEndpoint)](#withrefreshtokenendpoint-refreshtokenendpoint) | Configure the api with the URL that receives the refresh token requests.                                    |
| [CustomApiBuilder](/reference/servoyextensions/server-plugins/oauth/customapibuilder.md) | [withRevokeTokenEndpoint(revokeTokenEndpoint)](#withrevoketokenendpoint-revoketokenendpoint)     | Configure the api with the URL that receives the revoke token requests.                                     |

## Methods Detailed

### withAccessTokenExtractor(accessTokenExtractor)

Configures the api with a token extractor which parses the concrete type of token from the response string.

**Parameters**

* [String](/reference/servoycore/dev-api/js-lib/string.md) **accessTokenExtractor** see plugins.oauth.OAuthTokenExtractors

**Returns:** [CustomApiBuilder](/reference/servoyextensions/server-plugins/oauth/customapibuilder.md) the api builder for method chaining

### withAccessTokenMethod(tokenRequestMethod)

The request method used for the access token endpoint (defaults to POST).

**Parameters**

* [String](/reference/servoycore/dev-api/js-lib/string.md) **tokenRequestMethod** can be 'post' or 'get'

**Returns:** [CustomApiBuilder](/reference/servoyextensions/server-plugins/oauth/customapibuilder.md) the api builder for method chaining

### withClientAuthentication(clientAuthentication)

Configures the api with a client authentication method which specifies how the client credentials are sent.\
They can be sent as basic Auth header or in the request body.

**Parameters**

* [String](/reference/servoycore/dev-api/js-lib/string.md) **clientAuthentication** see plugins.oauth.ClientAuthentication

**Returns:** [CustomApiBuilder](/reference/servoyextensions/server-plugins/oauth/customapibuilder.md) the api builder for method chaining

### withRefreshTokenEndpoint(refreshTokenEndpoint)

Configure the api with the URL that receives the refresh token requests.

**Parameters**

* [String](/reference/servoycore/dev-api/js-lib/string.md) **refreshTokenEndpoint** ;

**Returns:** [CustomApiBuilder](/reference/servoyextensions/server-plugins/oauth/customapibuilder.md) the api builder for method chaining

### withRevokeTokenEndpoint(revokeTokenEndpoint)

Configure the api with the URL that receives the revoke token requests.

**Parameters**

* [String](/reference/servoycore/dev-api/js-lib/string.md) **revokeTokenEndpoint** ;

**Returns:** [CustomApiBuilder](/reference/servoyextensions/server-plugins/oauth/customapibuilder.md) the api builder for method chaining

***


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.servoy.com/reference/servoyextensions/server-plugins/oauth/customapibuilder.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
